package co.id.datacomsolusindo.ipphonebridge

import org.apache.logging.log4j.LogManager
import org.springframework.messaging.handler.annotation.DestinationVariable
import org.springframework.messaging.handler.annotation.MessageMapping
import org.springframework.messaging.handler.annotation.SendTo
import org.springframework.stereotype.Controller

@Controller
class SocketChecker {
//    @MessageMapping("/notification/{id}")
//    @SendTo("/topic/notification/{id}")
//    @Throws(Exception::class)
//    fun notification(@DestinationVariable("id") id: String, message: MutableMap<*, *>): MutableMap<*, *> {
//        return mutableMapOf(Pair("Hi", "I'am Ok"))
//    }

    @MessageMapping("/hi")
    @SendTo("/topic/healthCheck")
    @Throws(Exception::class)
    fun greeting(message: MutableMap<*, *>): MutableMap<*, *> {
        return mutableMapOf(Pair("Hi", "I'am Ok"))
    }

    @MessageMapping("/response/{id}")
    @SendTo("/topic/healthCheck")
    @Throws(Exception::class)
    fun responseMsg(message: SocketChunkData, @DestinationVariable("id") id: String): MutableMap<*, *> {
        try {
//            LogManager.getLogger(this.javaClass).info("req sent ${message.part} of ${message.totalPart}")
//            println("req sent ${message.part} of ${message.totalPart}")
            if (message.totalPart == 1) {
//                println("one part only with id $id")
                Singletons.responseQue.getOrPut(id) {
                    Resp(
                        message.body,
                        message.status,
                        message.header?.entries?.associate { Pair(it.key, it.value.toTypedArray()) }
                    )
                }
//                println("status code " + Singletons.responseQue[id]?.statusCode ?: "unknown code")
            } else {
                val sc = Singletons.buildSocketChunkData.getOrPut(id) { ChunkCollector(id) }
                sc.add(message)
            }
        } catch (e: Exception) {
            e.printStackTrace()
        }

        return mutableMapOf(Pair("Hi", "I'am Ok"))
    }
}